var _ = require('lodash'),
    fs = require('fs');

var filename = 'Mixed Corals high3.json';
var data = fs.readFileSync(filename, 'utf8');
var self = this;
data = data.replace(/^\uFEFF/, ''); // remove BOM from content (https://github.com/nodejs/node-v0.x-archive/issues/1918)
data = JSON.parse(data);

// clean all colors...
/*
data.colors = _.map(data.colors, function(color) {
    color["$$hashKey"] = undefined;
    color.values = _.map(color.values, function(value) {
        value["$$hashKey"] = undefined;
        return value;
    });
    for (var i = 0; i < 20; i++) {
        color["channel" + i] = undefined;
    }
    return color;
});
*/
data.colors = [];

// clean all timelines...
data.timelines = _.map(data.timelines, function(line) {
    var spots = _.groupBy(line.spots, function(spot) { return spot.name; });
    line.spots = [];
    _.each(spots, function(spot) {
        line.spots.push(spot[0]);
    });
    line.spots = _.map(line.spots, function(spot) {
        spot["externalId"] = undefined;
        spot["$$hashKey"] = undefined;
        spot["temperature"] = undefined;
        spot["showTemperature"] = undefined;
        spot["online"] = undefined;
        spot["_colorChannels"] = undefined;
        return spot;
    });

    line.inputValue = undefined;
    line.spotAddresses = undefined;
    line["$$hashKey"] = undefined;
    line.nodes = _.map(line.nodes, function(node) {
        node.color = {
            _id: node.color._id,
            name: node.color.name
        }
        return node;
    });
    return line;
});

data.info = undefined;

// save the file...
fs.writeFileSync(filename + '.cleaned', JSON.stringify(data, 0, 4));
