#!/bin/sh

# onion gpio16
# linkit gpio2
gpioPin=$(uci get system.@system[0].ati_gpio_reset)

echo "Reset-service listen on GPIO$gpioPin"
echo $gpioPin > /sys/class/gpio/unexport
echo $gpioPin > /sys/class/gpio/export
echo in > /sys/class/gpio/gpio$gpioPin/direction

a=0
b=0

resetFactory () {
	echo "RESET TO DEFAULT"

	/etc/init.d/ati2 stop;
	sleep 2;
	/etc/init.d/ati2 stop;
	sleep 2;
	/etc/init.d/ati2 stop;
	sleep 2;
	/etc/init.d/ati2 stop;
	sleep 5;

	(echo 'root'; sleep 1; echo 'root') | passwd 'root';
	rm -rf /www/ati/data/
	cp -R -f /www/ati/openwrt/www/ati/* /www/ati/

	sh /www/ati/scripts/initialize.sh --force

	reboot;
}

resetNetwork () {
	echo "RESET NETWORK"
	board=$(cat /var/sysinfo/model)

	if [ "$board" == "Onion Omega2+" ]; then
		sh /www/ati/scripts/onion.reset-network.sh
	else
		sh /www/ati/scripts/linkit.reset-network.sh
	fi
}

if [ "$1" != "--force" ]
then
	while [ $a -lt 20 ]
	do
		sleep 1s
		if [ $(cat /sys/class/gpio/gpio16/value) -eq 1 ]
		then
			a=$((a+1))
			echo "Reset button pressed: $a s"

			if [ $a == 4 ] ; then
				echo "RESET NETWORK POSSIBLE";
				/www/ati/scripts/led.sh --flash
			elif [ $a -gt 9 ]; then
				echo "FACTORY RESET";
				/www/ati/scripts/led.sh --on
				resetFactory
			fi

		elif [ $a -lt 10 ] && [ $a -gt 3 ]; then
			# button released between 3 and 10 seconds...
			a=0
			resetNetwork
			/www/ati/scripts/led.sh --network
		else
			if [ $a -gt 0 ]; then
				/www/ati/scripts/led.sh --network
			fi
			a=0
		fi
		
		if [ $b -gt 60 ]
		then
			b=0
			c=$(awk '{if (/MemAvailable:/) {print $2;exit}}' /proc/meminfo)
			if [ $c -lt 10000 ]
			then
				touch /etc/hosts;
				echo 'reboot needed!';
				echo $c
				sh /www/ati/scripts/write-debug-info.sh /www/ati/data/oom.log OOM-Exception;
				sleep 2;
				reboot;
			fi
		else
			b=$((b+1))
		fi
	done
fi

