/*! node-ati 2021-02-12 */

var _=require("lodash"),dgram=require("dgram"),net=require("net"),EventEmitter=require("events").EventEmitter,util=require("util"),Promise=require("promise"),JsonSocket=require("json-socket"),log4js=require("log4js"),_log=log4js.getLogger("net"),System=require("./../openwrt/system.js"),config=require("./../../config.js");config.isDebug&&(System=require("./../openwrt/system.debug.js"));var UDPPORT=33333,TCPPORT=33334,HOST=System.getWifiIP().replace(/((\d{1,3}\.){3})(\d{1,3})/,"$1255"),_options={multicastInterface:void 0,id:Date.now()};function ClusterMember(e){_options=_.merge({},_options,e);var o=this;o._refreshBroadCastAdress(),o._connections={},o._clientSocketsServer={},o._tcpServer=net.createServer(function(e){o._onTcpClientConnected(e)}),o._tcpServer.listen(TCPPORT,function(){_log.info("TCP server listening on %j",o._tcpServer.address())}),setInterval(function(){o._refreshBroadCastAdress()},3e4),o.on("ping",function(e){var t;_options.id!==e.request.id&&(t=!1,void 0===o._connections[e.request.id]&&(o._connections[e.request.id]={},t=!0),o._connections[e.request.id].lastTs=Date.now(),o._connections[e.request.id].address=e.remote.address,o._connections[e.request.id].id=e.request.id,t&&o.emit("new-device",o._connections[e.request.id]))})}util.inherits(ClusterMember,EventEmitter);var parseData=function(t){t=t.toString();var o={};try{o=JSON.parse(t)}catch(e){o=void 0,_log.error("UNKNOWN MESSAGE: "+t)}return o};ClusterMember.prototype._refreshBroadCastAdress=function(){var e=System.getWifiIP();this._hostAddress!==e&&(this._hostAddress=e,this._bcastAddress=this._hostAddress.replace(/((\d{1,3}\.){3})(\d{1,3})/,"$1255"))},ClusterMember.prototype._onTcpClientConnected=function(t){var o=this;(t=new JsonSocket(t))._socket.setTimeout(5e3),t._socket.on("timeout",function(){_log.warn("timeout connection "+t._socket.remoteAddress),t._socket.destroy()}),t.on("message",function(e){void 0!==e&&void 0!==e.command&&o.emit(e.command,{request:e,socket:t})}),t.on("close",function(){_log.warn("connection closed"),t._socket.destroy()}),t.on("error",function(e){_log.error("Connection: %s",e.message),t._socket.destroy()})},ClusterMember.prototype.hasConnections=function(){return 0<this._connections.length},ClusterMember.prototype.getConnections=function(){return this._connections},ClusterMember.prototype.sendUdpMessage=function(e,t){void 0!==this._udpSocket?(t=new Buffer(JSON.stringify({command:e,message:t,id:_options.id})),this._udpSocket.send(t,0,t.length,UDPPORT,this._bcastAddress,function(e,t){if(e)throw e})):_log.warn("No udp socket..."+e)},ClusterMember.prototype.sendUdpCommand=function(e){var t;void 0!==this._udpSocket?(t=new Buffer(JSON.stringify({command:e,id:_options.id})),this._udpSocket.send(t,0,t.length,UDPPORT,this._bcastAddress,function(e,t){if(e)throw e})):_log.warn("No udp socket..."+e)},ClusterMember.prototype.startListen=function(){var n=this;n._udpSocket=dgram.createSocket("udp4"),n._udpSocket.on("listening",function(){var e=n._udpSocket.address();_log.info("UDP Server listening on "+e.address+":"+e.port),n._udpSocket.setBroadcast(!0)}),n._udpSocket.on("message",function(e,t){n._onServerMessage(e,t)}),n._udpSocket.bind(UDPPORT),setInterval(function(){var o=Date.now()-3e5;n._connections=_.pickBy(n._connections,function(e,t){return e.lastTs>=o})},6e4)},ClusterMember.prototype.startPing=function(){var e=new Buffer(JSON.stringify({command:"ping",id:_options.id})),t=this;setInterval(function(){_log.debug("send ping to ",t._bcastAddress),t._udpSocket.send(e,0,e.length,UDPPORT,t._bcastAddress,function(e,t){if(e)throw e})},5e3)},ClusterMember.prototype._onServerMessage=function(e,t){var o=parseData(e);void 0!==o&&void 0!==o.command&&o.id!==_options.id?this.emit(o.command,{request:o,remote:t}):void 0===o&&_log.error("error:",e)},ClusterMember.prototype.createClient=function(e,t){var o=new JsonSocket(new net.Socket);return _log.info("Create client for "+e+":"+TCPPORT),o.connect(TCPPORT,e,function(){_log.info("Client connected to: "+e+":"+TCPPORT),void 0!==t&&t(o)}),o.on("close",function(){_log.info("Client closed")}),o.on("error",function(e){_log.error(e),void 0!==o&&void 0!==o._socket&&o._socket.destroy()}),o},ClusterMember.prototype.sendClientMessage=function(o,n){return new Promise(function(t,e){_log.debug("SEND DATA "+o._socket.remoteAddress),o._socket.setTimeout(5e3),o._socket.on("timeout",function(){_log.warn("timeout client connection!"),o._socket.destroy()}),o._socket.once("message",function(e){_log.info("END RECV DATA FROM SERVER!"),t({data:e,client:o}),o._socket.end()});try{o.sendMessage(n)}catch(e){_log.error(e),void 0!==o&&o._socket.destroy()}})},module.exports=ClusterMember;