/*! node-ati 2021-02-12 */

var sha1=require("sha1"),_=require("lodash"),Promise=require("promise"),Timelines=require("./model/timelines.js"),Timeline=require("./model/timeline.js"),config=require("./config.js"),log4js=require("log4js"),logger=log4js.getLogger("requests"),System=require("./lib/openwrt/system.js");function Requests(e){this._network=e.network,this._appSettings=e.appSettings,this._io=e.io,this._version=e.version,this._lines=e.lines,this._spots=e.spots,this._time=e.time,this._colors=e.colors,this._currentUser={name:"admin",sessionId:void 0}}config.isDebug&&(System=require("./lib/openwrt/system.debug.js")),Requests.prototype.updateData=function(e){this._network=void 0!==e.network?e.network:this._network,this._appSettings=void 0!==e.appSettings?e.appSettings:this._appSettings,this._io=void 0!==e.io?e.io:this._io,this._version=void 0!==e.version?e.version:this._version,this._lines=void 0!==e.lines?e.lines:this._lines,this._spots=void 0!==e.spots?e.spots:this._spots,this._colors=void 0!==e.colors?e.colors:this._colors},Requests.prototype.auth=function(e,s,t){e.session.user&&e.session.id===this._currentUser.sessionId?t():(e.session.error="Access denied!",s.redirect("/login"))},Requests.prototype.index=function(e,s){s.sendfile("./public/_index.html")},Requests.prototype.login=function(e,s){s.sendfile("./public/_login.html")},Requests.prototype.setup=function(e,s){s.sendfile("./public/_setup.html")},Requests.prototype.debugTemperatures=function(e,s){s.sendfile("./public/_debug-temperatures.html")},Requests.prototype.test=function(e,s){var t=this;sha1("admin")===t._appSettings.all().user.password?e.session.regenerate(function(){e.session.user={username:"admin"},t._currentUser.sessionId=e.session.id,s.sendfile("./public/_test.html")}):s.redirect("/login")},Requests.prototype.loginPost=function(e,s){var t=this;e.body.username==t._appSettings.all().user.name&&sha1(e.body.password)===t._appSettings.all().user.password?e.session.regenerate(function(){t._network.sendUdpCommand("logout"),t._io.emit("logout"),e.session.user={username:"demo"},t._currentUser.sessionId=e.session.id,s.redirect("/")}):s.redirect("/login")},Requests.prototype.version=function(e,s){s.json(this._version)},Requests.prototype.state=function(e,s){s.json({initialized:this._lines.Initialized()})},Requests.prototype.info=function(e,s){s.json({id:System.getId(),adc:void 0!==config.hasADC&&config.hasADC,showAllTemperatures:void 0!==config.showAllTemperatures&&config.showAllTemperatures,maxTemperature:config.maxTemperature})},Requests.prototype.user=function(e,s){s.json(this._appSettings.all().user)},Requests.prototype.uptime=function(e,s){seconds=Number(System.getUptime()),s.json({uptime:seconds,days:Math.floor(seconds/86400),hours:Math.floor(seconds%86400/3600),minutes:Math.floor(seconds%3600/60),seconds:Math.floor(seconds%60)})},Requests.prototype.channels=function(e,s){s.json(_.sortBy(this._spots.getChannelColors(),["sort","name"]))},Requests.prototype.spots=function(e,s){s.json(this._spots.getItems())},Requests.prototype.timelines=function(e,s){var t,o=this,i=o._network.getConnections();i?(t=[],_.forOwn(i,function(e,s){o._network.createClient(e.address,function(e){t.push(o._network.sendClientMessage(e,{command:"get-spots"}).then(function(e){o._spots.addExternalItems(e.data)}).catch(function(e){logger.error(e)}))})}),setTimeout(function(){Promise.all(t).then(function(){o._spots.save(),o._lines.setSpots(o._spots),s.json(o._lines.getItems())})},2e3)):s.json(o._lines.getItems())},Requests.prototype.timelinePut=function(e,s){var t=new Timelines(e.body.timelines),e=void 0===(e=_.last(t.getItems()))?new Timeline:((e=_.cloneDeep(e)).spots=[],e._id=void 0,new Timeline(e));t.add(e),s.json(e)},Requests.prototype.timelineVisiblePut=function(t,e){var o,i=this,s=i._lines.findById(t.body._id),n=i._network.getConnections();logger.debug(n),n&&(o=[],_.forOwn(n,function(e,s){i._network.createClient(e.address,function(e){o.push(i._network.sendClientMessage(e,{command:"timeline-visible",message:t.body}).then(function(e){logger.info(e)}).catch(function(e){logger.error(e)}))})})),void 0!==s&&(s.visible=t.body.visible,e.json({succes:!0})),e.json({succes:!1})},Requests.prototype.spotsVisiblePut=function(o,e){function s(){var t;logger.debug(r),r&&(t=[],_.forOwn(r,function(e,s){i._network.createClient(e.address,function(e){t.push(i._network.sendClientMessage(e,{command:"spots-active",message:o.body}).then(function(e){logger.info(e)}).catch(function(e){logger.error(e)}))})}))}var i=this,t=o.body.spots,n=o.body.active,r=i._network.getConnections();s(),setTimeout(s(),200),_.each(t,function(e){e=i._spots.findById(e);void 0!==e&&(e.active=n)}),e.json({succes:!0})},Requests.prototype.resetDevicePost=function(e,o){(0,require("child_process").exec)("./reset-settings.sh --force",function(e,s,t){e&&o.json({succes:!1}),o.json({succes:!0})})},Requests.prototype.changeUserPassword=function(t,o){var e=require("./lib/openwrt/user.js");this._appSettings.all().user.name=t.body.user.name,this._appSettings.all().user.password=sha1(t.body.user.password),this._appSettings.save(),e.setPW("root",t.body.user.password,function(e,s){e?logger.info("Change password for user "+t.body.user.name):logger.error("Error while changing password for user "+t.body.user.name+" message: "+s),o.json({valid:e,message:s})})},Requests.prototype.getPresettings=function(e,s){var t=new(require("./model/presettings.js"));t.load(),s.json(t.getItems())},Requests.prototype.loadPresettings=function(e,s){var t=require("./lib/utils/merge-settings.js"),o=new(require("./model/presettings.js"));o.load();e=o.findById(e.body._id);void 0!==e&&(e=t("./data/presettings/"+e.filename,!0),s.json(e)),s.json({valid:!1})},Requests.prototype.getTimeInfo=function(e,s){s.json({ts:this._time.getUtc(),offset:this._time.getOffset(),timezone:this._time.getTimezone(),systime:this._time.get()})},Requests.prototype.getTimeString=function(e,s){var t=this._time.get();s.json({time:t.toTimeString(),date:t.toDateString()})},Requests.prototype.getTime=function(e,s){s.json({ts:this._time.getTsWithTz(),initialized:this._time.isInitialized()})},Requests.prototype.getTimezone=function(e,s){s.json({timezone:this._time.getTimezone()})},Requests.prototype.setTimezone=function(e,s){var t=this._time.setTimezone(e.body.timezone);this._network.sendUdpMessage("set-timezone",{tz:e.body.timezone}),t||s.json({valid:!0,reset:!1}),s.json({valid:!0,reset:!0})},Requests.prototype.getColors=function(e,s){var t=require("./lib/utils/get-colors.js");s.json(t(this._spots,this._colors))},Requests.prototype.getWifis=function(e,s){System.scanWifis(function(e){s.json(e)})},Requests.prototype.getWifiConfig=function(e,s){var t={ap:System.getWifiApConfig(),sta:System.getWifiStationConfig(),staIP:System.getWifiStationIpAddress(),staEnabled:System.isWifiStationEnabled()};s.json(t)},Requests.prototype.setWifiConfig=function(e,s){logger.trace(e.body);var t=System.getWifiStationConfig(),o=System.getWifiApConfig();"sta"===e.body.mode?(t.ssid=e.body.ssid,t.password=e.body.password,t.disabled=!1,this._appSettings.all().isMaster=!1):"ap"===e.body.mode&&(o.ssid=e.body.ssid,o.password=e.body.password,t.disabled=!0,this._appSettings.all().isMaster=!0),System.setWifiStationDefaults(t),System.setWifiApDefaults(o),System.commitWifiSettings(),this._appSettings.save(),setTimeout(function(){System.reboot()},2e3),s.json({result:!0})},Requests.prototype.setHostname=function(e,s){e=e.body.hostname;void 0!==e&&""!==e||(e=System.getDefaultHostname()),s.json({result:System.setHostname(e),hostname:e})},Requests.prototype.getHostname=function(e,s){s.json({hostname:System.getHostname()})},Requests.prototype.getTemperatures=function(e,s){s.sendfile("./data/temperature.log")},Requests.prototype.getRawTemperatures=function(e,s){config.rawTemperatureLogfile?s.sendfile("./data/"+config.rawTemperatureLogfile):s.redirect("/")},Requests.prototype.removeTimeline=function(e,s){var t=new(require("./model/timelines.js"))(e.body.timelines);t.removeById(e.body.deleteTimelineId),t.setSpots(this._spots),t.setColors(this._colors),s.json(t.getItems())},Requests.prototype.loadSettingsFile=function(e,s){var t=require("./lib/utils/datafile.js"),o=require("./lib/utils/merge-settings.js"),e=e.files.selected_file;e&&""!==e.originalFilename&&(logger.info("try to merge backup file "+e.path),e=o(e.path,!0),t.cleanTempFolder(),s.json(e)),s.json({valid:!1})},Requests.prototype.createSupportFile=function(e,o){config.isDebug?o.json({success:!0}):(0,require("child_process").exec)("./create-debug-info.sh",function(e,s,t){e&&o.json({success:!1,msg:e}),o.json({success:!0})})},Requests.prototype.getSupportFile=function(e,s){s.sendfile("./support.tar.gz")},module.exports=Requests;