/*! node-ati 2021-02-12 */

var _=require("lodash"),fs=require("fs"),Spot=require("./spot.js"),System=require("./../lib/openwrt/system.ts.js").Factory.create(),Datafile=require("./../lib/utils/datafile.js"),config=require("./../config.js");function Spots(t,e){var o=this;if(this._initialized=void 0,this._items=[],this._dataFileName="./data/spots.json",this._settings=e,this._channelColors=null,this.maxLocalTemperature=0,this._checkTimeoutInterval=setInterval(function(){o._onCheckTimeoutInterval()},5e3),this._checkPowerInterval=setInterval(function(){o._onCheckPowerInterval()},3e5),void 0!==t)for(var o=this,r=0;r<t.length;r++)o.add(new Spot(t[r]))}Spots.prototype.Initialized=function(){return void 0===this._initialized&&(this._initialized=fs.existsSync(this._dataFileName)),this._initialized},Spots.prototype.add=function(t){_.some(this._items)&&(t._id=_.last(this._items)._id+1),void 0===t.externalId&&(t.externalId=System.getId()+":"+t._id),this._items.push(t)},Spots.prototype.findById=function(e){return _.find(this._items,function(t){return t._id==e})},Spots.prototype.removeById=function(e){_.remove(this._items,function(t){return t._id==e})},Spots.prototype.save=function(){var t=this.getRawData();Datafile.writeData(t,this._dataFileName),this._initialized=!0},Spots.prototype.addExternalItems=function(t){var e=this;_.forEach(t.spots,function(t){void 0!==t.externalId&&void 0===_.find(e._items,{externalId:t.externalId})&&(console.log("add spot ",t.externalId),e.add(new Spot(t)))})},Spots.prototype.getOwnItems=function(){return _.filter(this._items,function(t){return t.isLocal()})},Spots.prototype.getItems=function(t){return this._items},Spots.prototype.getChannelColors=function(){if(null!==this._channelColors)return this._channelColors;var e={},o=[],r=0;return _.forEach(this._items,function(t){_.forEach(t.channels,function(t){_.has(e,t.name)||(e[t.name]={name:t.name,sort:void 0===t.sort?0:t.sort})})}),_.forOwn(e,function(t,e){o.push({id:r++,label:"COLORNAME_"+t.name,value:0,name:t.name,sort:t.sort})}),this._channelColors=o,this._channelColors},Spots.prototype.load=function(){var t=Datafile.readData(this._dataFileName);if(void 0!==t){this._items=[];for(var e=0;e<t.length;e++)this.add(new Spot(t[e]))}},Spots.prototype.getRawData=function(){var t=_.cloneDeep(_.filter(this._items,function(t){return-1!==_.parseInt(t._id)}),!0);return t=_.map(t,function(t){return t.temperature=void 0,t.temperatureInvalid=void 0,t.lastOnlineUpdate=void 0,t.online=void 0,t.power=void 0,t._colorChannels=void 0,t})},Spots.prototype.updateLocalTemperature=function(r){var n=!1,i=0;_.forEach(this._items,function(t){return!t.isLocal()||(n||void 0===_.find(t.channels,{address:r.address})||(e=Math.round(10*r.value)/10,void 0===t.rawtemperature&&(t.rawtemperature=[]),void 0===(o=_.find(t.rawtemperature,function(t){return t.addr===r.address}))&&(o={value:e,addr:r.address},t.rawtemperature.push(o)),o.value=e,t.lastOnlineUpdate=Date.now(),t.online=!0,t.temperature=_.maxBy(t.rawtemperature,"value").value,n=!0),void(t.temperature>i&&(i=t.temperature)));var e,o}),this.maxLocalTemperature=i},Spots.prototype.removeExternalItems=function(){this._items=_.remove(this._items,function(t){return!t.isLocal()})},Spots.prototype.removeByExternalId=function(e){this._items=_.remove(this._items,function(t){return!(t.isPartOfExternalId(e)&&!t.isLocal())})},Spots.prototype.updateOnlineState=function(t){var e=t.request.id,o=!1;return _.forEach(this._items,function(t){t.isPartOfExternalId(e)&&(t.lastOnlineUpdate=Date.now(),t.online=!0,o=!0)}),o},Spots.prototype._onCheckTimeoutInterval=function(){_.forEach(this._items,function(t){t.lastOnlineUpdate<Date.now()-(t.isLocal()?12e4:5e3)&&(t.online=!1)})},Spots.prototype._onCheckPowerInterval=function(){_.forEach(this._items,function(t){t.updatePower()})},Spots.prototype.updateExternalTemperature=function(t){var o=this;_.forEach(t,function(e){_.forEach(o._items,function(t){return!!t.isLocal()||(t.externalId===e.externalId?(t.temperature=e.temperature,t.rawtemperature=e.rawtemperature,!1):void 0)})})},Spots.prototype.getTemperatures=function(){var e=[];return _.forEach(this._items,function(t){e.push({externalId:t.externalId,temperature:t.temperature})}),e},Spots.prototype.setTemperatures=function(t){var o=this;_.forEach(t,function(e){_.forEach(o._items,function(t){if(t.externalId===e.externalId)return t.temperature=e.temperature,!1})})},Spots.prototype.getChannelColors=function(){if(null!==this._channelColors)return this._channelColors;var e={},i=[],a=0;return _.forEach(this._items,function(t){_.forEach(t.channels,function(t){_.has(e,t.name)||(e[t.name]={name:t.name,sort:void 0===t.sort?0:t.sort})})}),_.forOwn(e,function(t,e){var o,r=1,n=void 0;void 0===config.colorFactors||void 0!==(o=_.find(config.colorFactors,{name:t.name}))&&(r=o.factor),void 0!==config.colorReduceTemperatures&&(n=_.find(config.colorReduceTemperatures,{name:t.name})),i.push({id:a++,label:"COLORNAME_"+t.name,value:0,name:t.name,sort:t.sort,factor:r,valueTemperature:n})}),this._channelColors=i,this._channelColors},module.exports=Spots;