/*! node-ati 2021-02-12 */

var p=require("./lib/utils/proxy.js"),Datafile=require("./lib/utils/datafile.js"),config=require("./config.js"),debug=config.isDebug,log4js=require("log4js"),appender=require("log4js-memory-appender"),logBuffer=[];log4js.loadAppender("memory",appender({buffer:logBuffer,maxBufferSize:20})),log4js.addAppender(log4js.appenders.memory()),log4js.setGlobalLogLevel(config.logLevel);var Memwatch,memwatch,logger=log4js.getLogger("server"),timestamp=isNaN("1613117438741")?(new Date).getTime():parseInt("1613117438741",10),softwareVersion={number:"2.3.1",date:new Date(timestamp)},Promise=require("promise"),Settings=require("./model/settings.js"),System=require("./lib/openwrt/system.ts.js").Factory.create(),SystemTime=require("./lib/system-time/index.js"),TemperatureLog=require("./lib/temperature-log/index.js"),TemperatureRequest=require("./lib/temperature-request/index.js"),DemoFactory=require("./lib/demo-machine/factory.js"),appSettings=new Settings,demo=void 0;void 0===config.memwatchLogfile||config.isDebug||(logger.info("Initialize memwatch"),Memwatch=require("./lib/memwatch"),memwatch=new Memwatch(config)),appSettings.load();var Current=require("./lib/utils/current.js"),globalCurrent=void 0;!0===config.hasADC&&((globalCurrent=new Current(debug)).startListen(),globalCurrent.on("change",function(e){io.emit("changed-current",e)})),debug?appSettings.all().webServerPort=5e3:(appSettings.all().webServerPort=5e3,appSettings.all().isCarambola=!0),System.isSystemInitialized()||System.initializeDefaultSettings(!0);var isSirius=appSettings.all().isSirius,sysTime=new SystemTime,express=require("express"),app=express(),bodyParser=require("body-parser"),methodOverride=require("method-override"),server=require("http").createServer(app),io=require("socket.io").listen(server),_=require("lodash"),fs=require("fs"),sha1=require("sha1"),Colors=require("./model/colors.js"),State=require("./model/state.js"),Presettings=require("./model/presettings.js"),Timelines=require("./model/timelines.js"),lines=new Timelines,previewLines=new Timelines,Spots=require("./model/spots.js"),spots=new Spots,colors=new Colors,NetworkMember=require("./lib/cluster/index.js"),mergeSettings=require("./lib/utils/merge-settings.js"),tempLog=new TemperatureLog(spots),tempReq=new TemperatureRequest,MessageHandler=require("./lib/messagehandler/index.js");colors.load(),spots.load(),lines.load(),lines.setSpots(spots),lines.setColors(colors),tempReq.setSpots(spots),tempLog.startLogging(),sysTime.logStart();var networkMember=new NetworkMember({id:System.getId()});networkMember.startListen(),networkMember.startPing(),networkMember.on("get-spots",function(e){logger.info("RECV get-spots from a client...");var t=spots.getItems();e.socket.sendMessage({name:System.getHostname(),externalId:System.getId(),spots:t})}),networkMember.on("get-device-info",function(e){logger.info("RECV get-device-info from a client...");spots.getItems();e.socket.sendMessage({name:System.getHostname(),externalId:System.getId(),swVersion:softwareVersion,ip:System.getWifiIP()})}),networkMember.on("logout",function(){io.emit("logout")}),networkMember.on("set-preview",function(e){var t=new Spots(e.request.message.spots),r=new Colors(e.request.message.colors);onSetPreview(e.request.message.timelines,t,r)}),networkMember.on("set-preview-timelines",function(e){var t=new Spots(e.request.message.spots),r=new Colors(e.request.message.colors);onSetPreview(e.request.message.timelines,t,r),e.socket.end(JSON.stringify({success:!0}))}),networkMember.on("toggle-preview",function(e){onTogglePreview(e.request.message.id,e.request.message.visible)}),networkMember.on("set-time",function(e){sysTime.set(e.request.message.ts,e.request.message.offset),void 0!==e.request.message.timezone&&void 0!==e.request.message.timezone.name&&sysTime.setTimezone(e.request.message.timezone)}),networkMember.on("set-time-interval",function(e){var t=sysTime.getUtc();(t-5e3>e.request.message.ts||t+5e3<e.request.message.ts)&&(sysTime.set(e.request.message.ts,e.request.message.offset),logger.info("Set time to "+new Date(e.request.message.ts).toISOString()),void 0!==e.request.message.timezone&&void 0!==e.request.message.timezone.name&&sysTime.setTimezone(e.request.message.timezone))}),networkMember.on("set-timezone",function(e){sysTime.setTimezone(e.request.message.tz)}),System.isWifiStationEnabled()||(void 0===appSettings.all().isMaster&&(appSettings.all().dataId=Date.now(),appSettings.all().isMaster=!0,appSettings.save()),setInterval(function(){var e={ts:sysTime.getUtc(),offset:sysTime.getOffset(),timezone:sysTime.getTimezone()};logger.debug("Send time info to all clients: ",e),networkMember.sendUdpMessage("set-time-interval",e)},3e5)),setInterval(function(){!0===appSettings.all().isMaster&&(logger.debug("Send timelines to all clients... dataId: ",appSettings.all().dataId),sendDataToClients(appSettings.all().dataId))},3e5);var timeInterval,saveAllData=function(e,t,s){var i=new Timelines(e),e=new Spots(t),t=new Colors(s),s=spots.getTemperatures();t.save(),e.save(),t.load(),e.load(),i.setSpots(e),i.setColors(t),i.save(),i.load(),i.setSpots(e),i.setColors(t),colors.load(),spots.load(),lines.load(),lines.setColors(colors),lines.setSpots(spots),spots.setTemperatures(s),r.updateData({lines:lines,spots:spots,colors:colors})},sendDataToClients=function(e){var r,s,t=networkMember.getConnections();logger.debug(t),t&&(r=[],s={ts:Date.now(),dataId:e,lines:lines.getRawData(),spots:spots.getRawData(),colors:colors.getItems()},_.forOwn(t,function(e,t){networkMember.createClient(e.address,function(e){r.push(networkMember.sendClientMessage(e,{command:"set-timelines",message:s}).then(function(e){logger.debug(e)}).catch(function(e){logger.error(e)}))})}))};networkMember.on("set-timelines",function(e){logger.info("RECV set-timelines from a master..."),appSettings.all().dataId!==e.request.message.dataId?(logger.info("Save new timelines from master..."),pauseTimer(),appSettings.all().isMaster=!1,appSettings.all().dataId=e.request.message.dataId,appSettings.save(),saveAllData(e.request.message.lines,e.request.message.spots,e.request.message.colors),e.socket.end(JSON.stringify({name:System.getHostname(),externalId:System.getId(),success:!0})),continueTimer()):logger.info("Already saved new timelines...")});var currentState=new State(isSirius,spots.getChannelColors()),getChannelValue=function(e,t){if(void 0!==t&&(2<e&&(e*=t.factor),void 0!==t.valueTemperature&&t.valueTemperature.max<e&&t.valueTemperature.temperature>spots.maxLocalTemperature&&(e=t.valueTemperature.max),void 0!==t.power&&(e*=t.power),1!==e||void 0!==t.previousValue&&0!==t.previousValue||(e=2)),isSirius)return(e=Math.round(e))<0&&(e=0),255<e&&(e=255),255-e;if(0===e)return 0;return Math.round(3+e*(252/255))};setInterval(function(){currentState.resetPreview()},5e3);var isPauseTimer=!1,pauseTimer=function(){isPauseTimer=!0},continueTimer=function(){isPauseTimer=!1};currentState.on("timePreview",function(e){timeInterval&&clearInterval(timeInterval),timeInterval=e?setInterval(onTimeTick,500):setInterval(onTimeTick,1e3)}),networkMember.on("color-change",function(e){e=e.request.message;currentState.setColorValue(e.name,e.value,e.spots)}),networkMember.on("preview-timestamp",function(e){e=e.request.message;currentState.setPreviewTimestamp(e.value,e.addresses)}),networkMember.on("color-preview",function(e){e=e.request.message;currentState.setIsColorPreview(e.enabled),e.enabled&&lines.resetPreviousValues()}),networkMember.on("color-demo",function(e){var t=e.request.message;currentState.isDemoMode!==t.enabled&&(e=new DemoFactory,demo=e.createDemo(t.demo,spots)),currentState.setIsDemo(t.enabled)}),networkMember.on("update-node",function(e){e=e.request.message;previewLines.updateNode(e.parent,e.index,e.time,e.value,e.color)}),networkMember.on("preview-stop",function(){currentState.stopPreview()}),networkMember.on("disconnect",function(){currentState.stopPreview()}),io.sockets.on("connection",function(e){e.on("color-change",function(e){currentState.setColorValue(e.name,e.value,e.spots),networkMember.sendUdpMessage("color-change",e),networkMember.sendUdpMessage("color-change",e)}),e.on("preview-timestamp",function(e){currentState.setPreviewTimestamp(e.value,e.addresses),networkMember.sendUdpMessage("preview-timestamp",e)}),e.on("color-preview",function(e){currentState.setIsColorPreview(e.enabled),networkMember.sendUdpMessage("color-preview",e),e.enabled&&lines.resetPreviousValues()}),e.on("test-preview",function(e){currentState.setIsTestPreview(e.enabled)}),e.on("color-demo",function(e){var t;currentState.isDemoMode!==e.enabled&&(t=new DemoFactory,demo=t.createDemo(e.demo,spots)),currentState.setIsDemo(e.enabled),networkMember.sendUdpMessage("color-demo",e),lines.resetPreviousValues()}),e.on("update-node",function(e){previewLines.updateNode(e.parent,e.index,e.time,e.value,e.color),networkMember.sendUdpMessage("update-node",e)}),e.on("preview-stop",function(e){currentState.stopPreview(),networkMember.sendUdpCommand("preview-stop"),logger.info("frontend: preview-stop")}),e.on("disconnect",function(){currentState.stopPreview(),networkMember.sendUdpCommand("disconnect"),logger.info("frontend: disconnect")}),lines.Initialized()||e.emit("initialize-data")});var proxy=new MessageHandler.Proxy,temperature=new MessageHandler.TemperatureHandler;void 0!==appSettings.all().tempratureCalculationMethod&&temperature.setCalculationMethod(appSettings.all().tempratureCalculationMethod),temperature.on("temperature-update",function(e){isPauseTimer||tempReq.updateData(e)}),tempReq.on("temperature-debug-log",function(e){io.emit("temperature-debug-log",e)}),setInterval(function(){var e;isPauseTimer||(e=_.map(spots.getItems(),function(e){return{temperature:e.temperature,externalId:e.externalId,rawtemperature:e.rawtemperature,online:void 0!==e.online&&e.online}}),io.emit("temperature-spots",e))},2e3),setInterval(function(){isPauseTimer||networkMember.sendUdpMessage("temperature",_.map(spots.getOwnItems(),function(e){return{temperature:e.temperature,rawtemperature:e.rawtemperature,externalId:e.externalId}}))},5e3),networkMember.on("timeline-visible",function(e){var t=lines.findById(e.request.message._id);void 0!==t&&(t.visible=e.request.message.visible)}),networkMember.on("spots-active",function(e){var t=e.request.message.spots,r=e.request.message.active;_.each(t,function(e){e=spots.findById(e);void 0!==e&&(e.active=r)})}),networkMember.on("temperature",function(e){spots.updateExternalTemperature(e.request.message)}),networkMember.on("ping",function(e){spots.updateOnlineState(e)}),networkMember.on("new-device",function(e){var t,s;!0!==appSettings.all().isMaster||(t=networkMember.getConnections())&&(s=[],_.forOwn(t,function(e,t){networkMember.createClient(e.address,function(e){s.push(networkMember.sendClientMessage(e,{command:"get-spots"}).then(function(e){spots.addExternalItems(e.data)}).catch(function(e){console.log(e)}))})}),setTimeout(function(){Promise.all(s).then(function(){spots.save(),lines.setSpots(spots)})},2e3)),setTimeout(function(){r.updateData({lines:lines,spots:spots,colors:colors}),io.emit("new-spots",{id:e.id}),!0===appSettings.all().isMaster&&sendDataToClients(appSettings.all().dataId)},1e4)});var fanSpeedHandler=new MessageHandler.FanSpeedHandler;fanSpeedHandler.on("fanspeed",function(t){var e,r;10<t||(e=spots.getItems(),r=!1,_.forEach(e,function(e){void 0!==e.fanSpeed&&(e.fanSpeed=parseInt(t,10),r=!0)}),r&&spots.save())}),proxy.addHandler(11,temperature),proxy.addHandler(89,fanSpeedHandler);var serialPort=require("./lib/communication/serial.ts.js").Factory.create(),initializeSerialport=function(){serialPort.initialize({baudRate:appSettings.all().baudrate,portName:appSettings.all().serialPort}),serialPort.on("data",function(e){for(var t=[],r=0;r<e.length;r++)t.push(e[r]);proxy.addRawData(t),io.emit("receive-data",t)}),serialPort.open(function(e){e?logger.error("serialport failed to open: "+e):(previewTimer=setInterval(onColorPreviewDemoTimer,50),setTimeout(function(){timeInterval=setInterval(onTimeTick,1e3)},3e3),e=[],tempReq.getInitalPackages(e),serialPort.sendPackages(e))})};appSettings.initialized()&&(logger.info("settings initialized!"),initializeSerialport());var morgan,tempratureCount=0,onColorPreviewDemoTimer=function(){if(!currentState.isColorPreview&&!currentState.isTestPreview||void 0===currentState.channelsPrevious||void 0===currentState.channels||currentState.isDemoMode){if(currentState.isDemoMode&&currentState.isColorPreview){demo.tick();s=demo.getPackages();if(_.some(s)){for(var e=[],t=0;t<s.length;t++){var r=s[t];e.push([r.address,r.channel,getChannelValue(r.value)])}serialPort.sendPackages(e)}}}else{for(var s=[],i=[],n=0;n<currentState.channels.length;n++)if(void 0!==currentState.channels[n]&&void 0!==currentState.channelsPrevious[n]&&currentState.channels[n].value!==currentState.channelsPrevious[n].value){i.push(_.cloneDeep(currentState.channelsPrevious[n]));for(var a=spots.getOwnItems(),o=getChannelValue(currentState.channels[n].value,currentState.channels[n]),p=0;p<a.length;p++)for(var l=a[p].getChannelsByColorName(currentState.channels[n].name),t=0;t<l.length;t++)0<=_.indexOf(currentState.previewSpots,a[p].externalId)?s.push([l[t].address,l[t].channel,o]):s.push([l[t].address,l[t].channel,getChannelValue(0)])}for(var u,n=0;n<currentState.channels.length;n++)0===currentState.channels[n].previousValue&&0!==currentState.channels[n].value||(currentState.channelsPrevious[n].value=currentState.channels[n].value),currentState.channels[n].previousValue=currentState.channels[n].value;if(tempReq.getPackages(s),s.length&&(u=_.cloneDeep(s),serialPort.sendPackages(s),serialPort.sendPackages(u),!0===config.hasADC&&globalCurrent.get(function(e){currentState.setIsDangerCurrent(e.max<e.adc)&&io.emit("danger-current",{color:i,current:e})})),currentState.isTestPreview&&tempratureCount--<=0){for(var s=[],m=1;m<=6;m++)s.push([m,11,11]);tempratureCount=40,serialPort.sendPackages(s)}}},onTimeTick=function(){if(!(currentState.isColorPreview||isPauseTimer||currentState.isTestPreview)&&lines.Initialized()&&void 0!==serialPort){var e=lines.getItems(),t=0;currentState.isTimePreview?(t=currentState.previewTimeStamp,e=previewLines.getItems()):t=sysTime.getTime();for(var r=[],s=0;s<e.length;s++){var i=e[s];if(i.active&&i.visible&&(!currentState.isTimePreview||currentState.isTimePreview&&i.visible))for(var n=i.getColorByTimestamp(t),a=0;a<n.values.length;a++)for(var o=n.values[a],p=i.getChannelsByColorName(o.name),l=0;l<p.length;l++){var u=o.value;p[l].active||(u=0),r.push([p[l].address,p[l].channel,getChannelValue(u,p[l])]),p[l].previousValue=u}else i.active&&(p=i.getAllChannels(),_.forEach(p,function(e){r.push([e.address,e.channel,getChannelValue(0)]),e.previousValue=0}))}tempReq.getPackages(r),currentState.isColorPreview||isPauseTimer||serialPort.sendPackages(r)}};app.use(express.static(__dirname+"/public")),app.use(express.bodyParser()),appSettings.all().isCarambola||(morgan=require("morgan"),app.use(morgan("dev"))),app.use(bodyParser.urlencoded({extended:"true"})),app.use(bodyParser.json()),app.use(bodyParser.json({type:"application/vnd.api+json"})),app.use(methodOverride()),app.use(require("express-session")({secret:"ati.flex",resave:!1,saveUninitialized:!1}));var Requests=require("./requests.js"),r=new Requests({network:networkMember,appSettings:appSettings,io:io,version:softwareVersion,lines:lines,spots:spots,time:sysTime,colors:colors}),RequestsConfig=require("./requests.config.js"),rc=new RequestsConfig({appSettings:appSettings});function requiredAuthentication(e,t,s){r.auth(e,t,s)}app.get("/",requiredAuthentication,p(r.index,r)),app.get("/login",p(r.login,r)),app.post("/login",p(r.loginPost,r)),app.get("/test",p(r.test,r)),app.get("/setup",requiredAuthentication,p(r.setup,r)),app.get("/config",requiredAuthentication,p(rc.config,rc)),app.get("/config/load",requiredAuthentication,p(rc.load,rc)),app.get("/debug",requiredAuthentication,p(r.debugTemperatures,r)),app.get("/api/version",requiredAuthentication,p(r.version,r)),app.get("/api/state",requiredAuthentication,p(r.state,r)),app.get("/api/info",requiredAuthentication,p(r.info,r)),app.get("/api/user",requiredAuthentication,p(r.user,r)),app.get("/api/uptime",requiredAuthentication,p(r.uptime,r)),app.get("/api/channels",requiredAuthentication,p(r.channels,r)),app.post("/api/user",requiredAuthentication,p(r.changeUserPassword,r)),app.post("/api/timezone",requiredAuthentication,p(r.setTimezone,r)),app.get("/api/timezone",requiredAuthentication,p(r.getTimezone,r)),app.get("/api/timelines",requiredAuthentication,p(r.timelines,r)),app.put("/api/timeline",requiredAuthentication,p(r.timelinePut,r)),app.put("/api/timeline-visible",requiredAuthentication,p(r.timelineVisiblePut,r)),app.post("/api/timeline",requiredAuthentication,p(r.removeTimeline,r)),app.get("/api/color-demos",requiredAuthentication,function(e,t){var r=new DemoFactory;t.json(r.getDemos())}),app.get("/api/spots",requiredAuthentication,p(r.spots,r)),app.put("/api/spots-active",requiredAuthentication,p(r.spotsVisiblePut,r)),app.post("/api/delete-spot",requiredAuthentication,function(e,t){spots.removeByExternalId(e.body.externalId),appSettings.all().dataId=Date.now(),appSettings.save(),saveAllData(lines.getItems(),spots.getItems(),colors.getItems()),sendDataToClients(appSettings.all().dataId),t.json({lines:lines.getItems(),spots:spots.getItems(),colors:colors.getItems()})}),app.post("/api/reset-device",requiredAuthentication,p(r.resetDevicePost,r)),app.put("/api/data",requiredAuthentication,function(e,t){pauseTimer(),appSettings.all().isMaster=!0,appSettings.all().dataId=Date.now(),appSettings.save(),saveAllData(e.body.timelines,e.body.spots,e.body.colors),sendDataToClients(appSettings.all().dataId);e=[];tempReq.getInitalPackages(e),serialPort.sendPackages(e),continueTimer(),t.json({lines:lines.getItems(),spots:spots.getItems(),colors:colors.getItems()})}),app.get("/ADC/:value",requiredAuthentication,function(e,t){e=parseInt(e.params.value,10);globalCurrent.setSimulatedAdcValue(e),t.json()}),app.get("/initialize-defaults",requiredAuthentication,function(e,t){System.initializeDefaultSettings(!0),t.json()}),app.get("/api/status",requiredAuthentication,function(e,t){t.json(currentState)}),app.get("/api/raw-temperatures",requiredAuthentication,function(e,t){t.json({temperatures:tempReq.getRawTemperatures(),ts:Date.now()})});var onSetPreview=function(e,t,r){(previewLines=new Timelines(e)).setSpots(t),previewLines.setColors(r)},onTogglePreview=function(e,t){e=previewLines.findById(e);void 0!==e&&(e.visible=t)};app.put("/api/preview-toggle",requiredAuthentication,function(e,t){networkMember.sendUdpMessage("toggle-preview",{id:e.body.id,visible:e.body.visible}),setTimeout(function(){networkMember.sendUdpMessage("toggle-preview",{id:e.body.id,visible:e.body.visible})},200),onTogglePreview(e.body.id,e.body.visible),t.json(previewLines.getItems())}),app.put("/api/preview",requiredAuthentication,function(e,t){onSetPreview(e.body.timelines,spots,colors),networkMember.sendUdpMessage("set-preview",{timelines:e.body.timelines,spots:spots.getRawData(),colors:colors.getItems()});var r,s,i=networkMember.getConnections();logger.debug(i),i&&(r=[],s={timelines:e.body.timelines,spots:spots.getRawData(),colors:colors.getItems()},_.forOwn(i,function(e,t){networkMember.createClient(e.address,function(e){r.push(networkMember.sendClientMessage(e,{command:"set-preview-timelines",message:s}).then(function(e){logger.debug(e)}).catch(function(e){logger.error(e)}))})})),t.json(previewLines.getItems())}),app.get("/api/colors",requiredAuthentication,p(r.getColors,r)),app.get("/api/wifis",requiredAuthentication,p(r.getWifis,r)),app.get("/api/wifi",requiredAuthentication,p(r.getWifiConfig,r)),app.post("/api/wifi",requiredAuthentication,p(r.setWifiConfig,r)),app.post("/api/hostname",requiredAuthentication,p(r.setHostname,r)),app.get("/api/hostname",requiredAuthentication,p(r.getHostname,r)),app.get("/api/log",requiredAuthentication,function(e,t){t.json({log:logBuffer})}),app.get("/api/restarts",requiredAuthentication,function(e,t){t.sendfile("./data/restart.timestamp.json")}),app.get("/api/timeinfo",requiredAuthentication,p(r.getTimeInfo,r)),app.get("/api/timestring",requiredAuthentication,p(r.getTimeString,r)),app.get("/api/time",requiredAuthentication,p(r.getTime,r)),app.post("/api/time",requiredAuthentication,function(e,t){var r=new Date(e.body.ts),s=new Date;logger.error("new timestamp -- old: "+s.toISOString()+"("+sysTime.getOffset()+"), new: "+r.toISOString()+"("+e.body.offset+")"),sysTime.set(e.body.ts,e.body.offset),networkMember.sendUdpMessage("set-time",{ts:e.body.ts,offset:e.body.offset,timezone:sysTime.getTimezone()}),t.json({ts:sysTime.get()})}),app.get("/api/language",requiredAuthentication,function(e,t){t.json({language:appSettings.all().language})}),app.get("/api/fanSpeed",requiredAuthentication,function(e,t){var r=spots.getItems(),s=!1;_.forEach(r,function(e){if(void 0!==e.fanSpeed)return s=parseInt(e.fanSpeed,10),!1}),t.json({value:s})}),app.post("/api/fanSpeed",requiredAuthentication,function(t,e){var r=spots.getItems(),s=!1;_.forEach(r,function(e){void 0!==e.fanSpeed&&(e.fanSpeed=parseInt(t.body.value,10),debug||isNaN(e.fanSpeed)||(serialPort.write([e.address,88,255-e.fanSpeed]),serialPort.write([e.address,4,255-e.fanSpeed])),s=!0)}),s&&spots.save(),e.json({updated:s})}),app.post("/api/test",requiredAuthentication,function(i,n){var e=0;void 0===serialPort&&(appSettings.create(i.body.lamp),isSirius=appSettings.all().isSirius,initializeSerialport(),e=1e3);var a=appSettings.all().application.test.step;appSettings.all().application.test.delay;setTimeout(function(){var e=null,t=1,r=!0,s=50;"T5"===i.body.type&&(s=100,serialPort.write([i.body.address,88,249])),e=setInterval(function(){getChannelValue(t);r&&t<=i.body.value[0]?t+=a:(r=!1,t-=a),t<=0&&(t=0,"LED"===i.body.type&&serialPort.write([i.body.address,11,11]),n.json({success:!0}),clearInterval(e)),serialPort.write([i.body.address,1,getChannelValue(t)]),"T5"!==i.body.type&&(serialPort.write([i.body.address,2,getChannelValue(t)]),serialPort.write([i.body.address,3,getChannelValue(t)]),serialPort.write([i.body.address,4,getChannelValue(t)]))},s)},e)}),app.post("/api/setup",requiredAuthentication,function(r,s){appSettings.create(r.body.hardwareType.type),appSettings.all().user.name=r.body.user.name,appSettings.all().user.password=sha1(r.body.user.password),appSettings.all().user.timezone=r.body.user.timezone,void 0!==appSettings.all().defaultColors&&(colors=new Colors(appSettings.all().defaultColors)).save(),appSettings.save(),setTimeout(function(){colors.load(),require("./lib/openwrt/user.js").setPW("root",r.body.user.password,function(e,t){s.json({success:e}),sysTime.setTimezone(r.body.timezone)}),s.json({success:!0})},2e3)}),app.post("/firmware-update",requiredAuthentication,function(e,s){var i=e.files.selected_file,n=!1,a="";debug&&(n=!0,i.originalFilename=""),i&&0<i.originalFilename.indexOf(".tar")?(Datafile.cleanTempFolder(i.path),s.json({valid:!0,file:i.path,original:i.originalFilename,msg:a})):i&&""!==i.originalFilename?(n=!0,(0,require("child_process").exec)("sysupgrade -T "+i.path,function(e,t,r){""!==t&&(logger.error(t),a=t,n=!1),s.json({valid:n,file:i.path,original:i.originalFilename,msg:a})})):s.json({valid:n,file:i.path,original:i.originalFilename,msg:a})}),app.get("/firmware-update/:filename",requiredAuthentication,function(e,i){var t=require("child_process").exec,n=e.params.filename;logger.info(n),0<n.indexOf(".tar")?t("rm -rf /tmp/data-temp",null,function(e,t,r){if(e)return i.json({file:n}),logger.error(e),logger.info(t),void logger.error(r);fs.mkdirSync("/tmp/data-temp");var s=require("child_process").exec;s("tar -xf "+n+" -C /tmp/data-temp",null,function(e,t,r){e&&logger.error(e),s("sh /tmp/data-temp/patch.sh",null,function(e,t,r){e&&logger.error(e),s("rm -rf /tmp/data-temp",null,function(e,t,r){setTimeout(function(){process.exit(0)},3e3)})})}),i.json({file:n,redirect:"/login"})}):(t=require("child_process").exec,e="sysupgrade "+n,logger.info("run command: "+e),t(e,function(e,t,r){logger.error(e),logger.info(t),logger.error(r)}),i.json({file:n}))}),app.post("/upload-settings",requiredAuthentication,p(r.loadSettingsFile,r)),app.get("/api/presettings",requiredAuthentication,p(r.getPresettings,r)),app.post("/load-presettings",requiredAuthentication,p(r.loadPresettings,r)),app.get("/api/temperatures",requiredAuthentication,p(r.getTemperatures,r)),app.get("/api/rawtemperatures",requiredAuthentication,p(r.getRawTemperatures,r)),app.get("/api/create-support-file",requiredAuthentication,p(r.createSupportFile,r)),app.get("/api/support-file",requiredAuthentication,p(r.getSupportFile,r)),app.get("/api/devices",requiredAuthentication,p(r.getDevices,r)),server.listen(config.webserverPort),logger.info("App listening on port "+config.webserverPort);